<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: WebSocket.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">WebSocket.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * WebSocket.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Sep 2, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_WEBSOCKET_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_WEBSOCKET_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;Socket.h&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#undef close</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#undef send</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">class </span><a class="code" href="classWebSocketReader.html">WebSocketReader</a>;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">class </span><a class="code" href="classWebSocket.html">WebSocket</a>;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// +-------------------------------+</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">// | WebSocketInputStreambuf |</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">// +-------------------------------+</span></div><div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="classWebSocketInputStreambuf.html">   21</a></span>&#160;<span class="keyword">class </span><a class="code" href="classWebSocketInputStreambuf.html">WebSocketInputStreambuf</a> : <span class="keyword">public</span> std::streambuf {</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <a class="code" href="classWebSocketInputStreambuf.html#a89ecd4bd0c30e8681bce57217b107502">WebSocketInputStreambuf</a>(</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        <a class="code" href="classSocket.html">Socket</a>   socket,</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="keywordtype">size_t</span>   dataLength,</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        uint8_t* pMask = <span class="keyword">nullptr</span>,</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="keywordtype">size_t</span>   bufferSize = 2048);</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <a class="code" href="classWebSocketInputStreambuf.html#ab2452c9871aa4c0404e773d6b7dc02cb">~WebSocketInputStreambuf</a>();</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    int_type <a class="code" href="classWebSocketInputStreambuf.html#aed7065a593c58510569031142ce62e94">underflow</a>();</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classWebSocketInputStreambuf.html#af91a50709423669d4ade7713a612dc64">discard</a>();</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordtype">size_t</span> <a class="code" href="classWebSocketInputStreambuf.html#a8cf5dcebbeefc1670767ac619472e0bb">getRecordSize</a>();</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keywordtype">char</span>*    m_buffer;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <a class="code" href="classSocket.html">Socket</a>   m_socket;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">size_t</span>   m_dataLength;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">size_t</span>   m_bufferSize;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">size_t</span>   m_sizeRead;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    uint8_t* m_pMask;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;};</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment">// +------------------+</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment">// | WebSocketHandler |</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="comment">// +------------------+</span></div><div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="classWebSocketHandler.html">   47</a></span>&#160;<span class="keyword">class </span><a class="code" href="classWebSocketHandler.html">WebSocketHandler</a> {</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classWebSocketHandler.html#a18479a69a03eeed897c4334543023724">~WebSocketHandler</a>();</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classWebSocketHandler.html#a0ae1d5bde410e9f720bcc007ffd4cd0e">onClose</a>();</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classWebSocketHandler.html#a0bd22f329ec6953580c3d4907e5ecc18">onMessage</a>(<a class="code" href="classWebSocketInputStreambuf.html">WebSocketInputStreambuf</a>* pWebSocketInputStreambuf, <a class="code" href="classWebSocket.html">WebSocket</a>* pWebSocket);</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classWebSocketHandler.html#a0cc7913f3f6c9ae8e390401db99e659e">onError</a>(std::string error);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;};</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment">// +-----------+</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="comment">// | WebSocket |</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">// +-----------+</span></div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classWebSocket.html">   60</a></span>&#160;<span class="keyword">class </span><a class="code" href="classWebSocket.html">WebSocket</a> {</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_NORMAL_CLOSURE        = 1000;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_GOING_AWAY            = 1001;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_PROTOCOL_ERROR        = 1002;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_CANNOT_ACCEPT         = 1003;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_NO_STATUS_CODE        = 1005;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_CLOSED_ABNORMALLY     = 1006;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_NOT_CONSISTENT        = 1007;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_VIOLATED_POLICY       = 1008;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_TOO_BIG               = 1009;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_NO_EXTENSION          = 1010;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_UNEXPECTED_CONDITION  = 1011;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_SERVICE_RESTART       = 1012;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_TRY_AGAIN_LATER       = 1013;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint16_t CLOSE_TLS_HANDSHAKE_FAILURE = 1015;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint8_t SEND_TYPE_BINARY = 0x01;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint8_t SEND_TYPE_TEXT   = 0x02;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <a class="code" href="classWebSocket.html#a30c8399db86bb20fdc8facd5d68c79de">WebSocket</a>(<a class="code" href="classSocket.html">Socket</a> socket);</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classWebSocket.html#a48afbe9b82fde4479913a1b931444729">~WebSocket</a>();</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordtype">void</span>              <a class="code" href="classWebSocket.html#a57b53de6aeafeb1f57eed90a3357aaa8">close</a>(uint16_t status = CLOSE_NORMAL_CLOSURE, std::string message = <span class="stringliteral">&quot;&quot;</span>);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <a class="code" href="classWebSocketHandler.html">WebSocketHandler</a>* <a class="code" href="classWebSocket.html#a93cd22aa94f9c0ef2a49e78a822aaa88">getHandler</a>();</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <a class="code" href="classSocket.html">Socket</a>            <a class="code" href="classWebSocket.html#aab1c6f5102716a4200d930ec0e63546e">getSocket</a>();</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="keywordtype">void</span>              <a class="code" href="classWebSocket.html#a9632cea9451d149a1dda489a3d0975cf">send</a>(std::string data, uint8_t sendType = SEND_TYPE_BINARY);</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keywordtype">void</span>              <a class="code" href="classWebSocket.html#a9632cea9451d149a1dda489a3d0975cf">send</a>(uint8_t* data, uint16_t length, uint8_t sendType = SEND_TYPE_BINARY);</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordtype">void</span>              <a class="code" href="classWebSocket.html#aad812ebe8eb8405006c0ed8c8e567239">setHandler</a>(<a class="code" href="classWebSocketHandler.html">WebSocketHandler</a> *handler);</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classWebSocketReader.html">WebSocketReader</a>;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classHttpServerTask.html">HttpServerTask</a>;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="keywordtype">void</span>              startReader();</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keywordtype">bool</span>              m_receivedClose; <span class="comment">// True when we have received a close request.</span></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keywordtype">bool</span>              m_sentClose;   <span class="comment">// True when we have sent a close request.</span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <a class="code" href="classSocket.html">Socket</a>            m_socket;     <span class="comment">// Partner socket.</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <a class="code" href="classWebSocketHandler.html">WebSocketHandler</a>* m_pWebSocketHandler;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <a class="code" href="classWebSocketReader.html">WebSocketReader</a>*  m_pWebSockerReader;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;}; <span class="comment">// WebSocket</span></div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_WEBSOCKET_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classSocket_html"><div class="ttname"><a href="classSocket.html">Socket</a></div><div class="ttdoc">Encapsulate a socket.</div><div class="ttdef"><b>Definition:</b> Socket.h:62</div></div>
<div class="ttc" id="classWebSocketInputStreambuf_html_ab2452c9871aa4c0404e773d6b7dc02cb"><div class="ttname"><a href="classWebSocketInputStreambuf.html#ab2452c9871aa4c0404e773d6b7dc02cb">WebSocketInputStreambuf::~WebSocketInputStreambuf</a></div><div class="ttdeci">~WebSocketInputStreambuf()</div><div class="ttdoc">Destructor.</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:423</div></div>
<div class="ttc" id="classWebSocketInputStreambuf_html_aed7065a593c58510569031142ce62e94"><div class="ttname"><a href="classWebSocketInputStreambuf.html#aed7065a593c58510569031142ce62e94">WebSocketInputStreambuf::underflow</a></div><div class="ttdeci">int_type underflow()</div><div class="ttdoc">Handle the request to read data from the stream but we need more data from the source.</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:465</div></div>
<div class="ttc" id="classWebSocketReader_html"><div class="ttname"><a href="classWebSocketReader.html">WebSocketReader</a></div><div class="ttdoc">A task that will watch web socket inputs.</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:96</div></div>
<div class="ttc" id="classWebSocketHandler_html_a0cc7913f3f6c9ae8e390401db99e659e"><div class="ttname"><a href="classWebSocketHandler.html#a0cc7913f3f6c9ae8e390401db99e659e">WebSocketHandler::onError</a></div><div class="ttdeci">virtual void onError(std::string error)</div><div class="ttdoc">The default onError handler. If no over-riding handler is provided for the &quot;error&quot; event,...</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:230</div></div>
<div class="ttc" id="classWebSocket_html_aab1c6f5102716a4200d930ec0e63546e"><div class="ttname"><a href="classWebSocket.html#aab1c6f5102716a4200d930ec0e63546e">WebSocket::getSocket</a></div><div class="ttdeci">Socket getSocket()</div><div class="ttdoc">Get the underlying socket for the websocket.</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:312</div></div>
<div class="ttc" id="classWebSocketHandler_html_a0bd22f329ec6953580c3d4907e5ecc18"><div class="ttname"><a href="classWebSocketHandler.html#a0bd22f329ec6953580c3d4907e5ecc18">WebSocketHandler::onMessage</a></div><div class="ttdeci">virtual void onMessage(WebSocketInputStreambuf *pWebSocketInputStreambuf, WebSocket *pWebSocket)</div><div class="ttdoc">The default onData handler. If no over-riding handler is provided for the &quot;message&quot; event,...</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:220</div></div>
<div class="ttc" id="classWebSocketInputStreambuf_html"><div class="ttname"><a href="classWebSocketInputStreambuf.html">WebSocketInputStreambuf</a></div><div class="ttdef"><b>Definition:</b> WebSocket.h:21</div></div>
<div class="ttc" id="classWebSocketInputStreambuf_html_a89ecd4bd0c30e8681bce57217b107502"><div class="ttname"><a href="classWebSocketInputStreambuf.html#a89ecd4bd0c30e8681bce57217b107502">WebSocketInputStreambuf::WebSocketInputStreambuf</a></div><div class="ttdeci">WebSocketInputStreambuf(Socket socket, size_t dataLength, uint8_t *pMask=nullptr, size_t bufferSize=2048)</div><div class="ttdoc">Create a Web Socket input record streambuf.</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:404</div></div>
<div class="ttc" id="classWebSocket_html_a30c8399db86bb20fdc8facd5d68c79de"><div class="ttname"><a href="classWebSocket.html#a30c8399db86bb20fdc8facd5d68c79de">WebSocket::WebSocket</a></div><div class="ttdeci">WebSocket(Socket socket)</div><div class="ttdoc">Construct a WebSocket instance.</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:239</div></div>
<div class="ttc" id="classWebSocketHandler_html_a0ae1d5bde410e9f720bcc007ffd4cd0e"><div class="ttname"><a href="classWebSocketHandler.html#a0ae1d5bde410e9f720bcc007ffd4cd0e">WebSocketHandler::onClose</a></div><div class="ttdeci">virtual void onClose()</div><div class="ttdoc">The default onClose handler. If no over-riding handler is provided for the &quot;close&quot; event,...</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:204</div></div>
<div class="ttc" id="classWebSocket_html"><div class="ttname"><a href="classWebSocket.html">WebSocket</a></div><div class="ttdef"><b>Definition:</b> WebSocket.h:60</div></div>
<div class="ttc" id="classWebSocketHandler_html_a18479a69a03eeed897c4334543023724"><div class="ttname"><a href="classWebSocketHandler.html#a18479a69a03eeed897c4334543023724">WebSocketHandler::~WebSocketHandler</a></div><div class="ttdeci">virtual ~WebSocketHandler()</div><div class="ttdoc">Destructor.</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:511</div></div>
<div class="ttc" id="classWebSocketInputStreambuf_html_a8cf5dcebbeefc1670767ac619472e0bb"><div class="ttname"><a href="classWebSocketInputStreambuf.html#a8cf5dcebbeefc1670767ac619472e0bb">WebSocketInputStreambuf::getRecordSize</a></div><div class="ttdeci">size_t getRecordSize()</div><div class="ttdoc">Get the size of the expected record.</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:456</div></div>
<div class="ttc" id="classWebSocketHandler_html"><div class="ttname"><a href="classWebSocketHandler.html">WebSocketHandler</a></div><div class="ttdef"><b>Definition:</b> WebSocket.h:47</div></div>
<div class="ttc" id="classHttpServerTask_html"><div class="ttname"><a href="classHttpServerTask.html">HttpServerTask</a></div><div class="ttdoc">Be an HTTP server task. Here we define a Task that will be run when the HTTP server starts....</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:53</div></div>
<div class="ttc" id="classWebSocket_html_aad812ebe8eb8405006c0ed8c8e567239"><div class="ttname"><a href="classWebSocket.html#aad812ebe8eb8405006c0ed8c8e567239">WebSocket::setHandler</a></div><div class="ttdeci">void setHandler(WebSocketHandler *handler)</div><div class="ttdoc">Set the Web socket handler associated with this Websocket.</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:382</div></div>
<div class="ttc" id="classWebSocketInputStreambuf_html_af91a50709423669d4ade7713a612dc64"><div class="ttname"><a href="classWebSocketInputStreambuf.html#af91a50709423669d4ade7713a612dc64">WebSocketInputStreambuf::discard</a></div><div class="ttdeci">void discard()</div><div class="ttdoc">Discard data for the record that has not yet been read.</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:441</div></div>
<div class="ttc" id="classWebSocket_html_a48afbe9b82fde4479913a1b931444729"><div class="ttname"><a href="classWebSocket.html#a48afbe9b82fde4479913a1b931444729">WebSocket::~WebSocket</a></div><div class="ttdeci">virtual ~WebSocket()</div><div class="ttdoc">Destructor.</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:251</div></div>
<div class="ttc" id="classWebSocket_html_a57b53de6aeafeb1f57eed90a3357aaa8"><div class="ttname"><a href="classWebSocket.html#a57b53de6aeafeb1f57eed90a3357aaa8">WebSocket::close</a></div><div class="ttdeci">void close(uint16_t status=CLOSE_NORMAL_CLOSURE, std::string message=&quot;&quot;)</div><div class="ttdoc">Close the Web socket.</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:262</div></div>
<div class="ttc" id="classWebSocket_html_a93cd22aa94f9c0ef2a49e78a822aaa88"><div class="ttname"><a href="classWebSocket.html#a93cd22aa94f9c0ef2a49e78a822aaa88">WebSocket::getHandler</a></div><div class="ttdeci">WebSocketHandler * getHandler()</div><div class="ttdoc">Get the current WebSocketHandler A web socket handler is a user registered class instance that is cal...</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:303</div></div>
<div class="ttc" id="classWebSocket_html_a9632cea9451d149a1dda489a3d0975cf"><div class="ttname"><a href="classWebSocket.html#a9632cea9451d149a1dda489a3d0975cf">WebSocket::send</a></div><div class="ttdeci">void send(std::string data, uint8_t sendType=SEND_TYPE_BINARY)</div><div class="ttdoc">Send data down the web socket See the WebSocket spec (RFC6455) section &quot;6.1 Sending Data&quot;....</div><div class="ttdef"><b>Definition:</b> WebSocket.cpp:324</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
